<!DOCTYPE html> 
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="content-type" content="text/html; charset=utf-8"/>
    <title>Z-Way</title>
	<meta name="viewport" content="width=device-width, initial-scale=1"> 
	<link rel="stylesheet" href="/css/jquery.mobile.css" />
	<script type="text/javascript" src="/js/jquery.js"></script>
	<script type="text/javascript" src="/js/jquery.mobile.js"></script>
	<script type="text/javascript" src="/js/mobile.js"></script>
	
<script type="text/javascript">
 ZWaveAPIDataUpdate_init()

function sendServer(cmd) {
    var url = "http://" + document.location.host + document.location.pathname+"?cmd=" + cmd;
    var postvars = JSON.stringify(cmd);
    var req =  new XMLHttpRequest();
	req.onreadystatechange = reqStateChange;  
    req.open('POST', url, false);
    try { req.send(postvars); }
    catch(e) { return null; }
    return null;
}
function reqStateChange() { }
</script>
</head>
<body> 
<?php
#$host="192.168.1.35";
$host="localhost";
$port=8083;
date_default_timezone_set('Europe/Paris');
$nodeNames = getNames();
$data = array(); // has the data model
$rooms = array();
parseAreas(); // fills the rooms with content
$data =  json_decode(PostRequest("/ZWaveAPI/Data/0", "", array(),false,1), true);



if (array_key_exists("cmd", $_REQUEST)) {
	$req = sprintf("/ZWaveAPI/Run/%s",$_REQUEST[cmd]);
	json_decode(PostRequest($req, "", array()), true);
	exit(1);
	}

function CreateDimmerLine($ccId,$ccd,$nodeId){    
	$level = $ccd['level']['value'];
	return sprintf("<div data-role='fieldcontain'><label for='slider'>%s</label><br>
 		<input type='range' name='slider' id='slider' value='0' min='0' max='100'  /></div>",
 		GetNodeName($dev,$nodeId,$instanceId));
 	}

function CreateSwitchLine($ccId,$ccd,$nodeId){    
	if ($ccd['level']['value']>0) $status="on"; else $status="off";
	$s = sprintf("<div data-role='fieldcontain'> <label for='slider'>%s is %s</label><br>
		<select name='slider' id='slider_%d' data-role='slider'
		onchange=sendServer('devices[%s].instances[0].Basic.Set('+$(slider_%d).val()+')') rel='external'>
		<option value=0 >Off</option><option value=1>On</option></select> </div>",
		GetNodeName($dev,$nodeId,$instanceId),$status,$nodeId,$nodeId,$nodeId);
	return $s;
	}

function CreateBlindLine($ccId,$ccd,$nodeId){    
	$level = $ccd['level']['value'];
	return sprintf("<div data-role='fieldcontain'><label for='slider'>%s</label><br>
 		<input type='range' name='slider' id='slider_%d' 
		onchange=sendServer('devices[%s].instances[0].Basic.Set('+$(slider_%d).val()+')') 		
 		value='0' min='0' max='100' /></div>",
 		GetNodeName($dev,$nodeId,$instanceId,1),$nodeId,$nodeId,$nodeId);
 	}

 
function printAreas(){
	global $rooms;
	foreach($rooms as $key => $value) {
		printf ("<li><a href='#room' data-transition='pop'>%s (%d)</a></li>",$value['name'],$key);
	}
}
 

function printScenes(){
	echo "<table border=1>";
	$p = xml_parser_create();
	xml_parse_into_struct($p, PostRequest("/Config/Rules/Get", "", array(),true), $v1, $v2);
	xml_parser_free($p);
//	var_dump($v1);
	for ($i=0;$i<count($v1);$i++) {
		if ($v1[$i]['tag']=="SCENE" && $v1[$i]['type']=="open") {
			$sceneId = $v1[$i]['attributes']['ID'];
			$areaId = $v1[$i]['attributes']['AREA'];			
		    while ($i<count($v1) && $v1[$i]['type']!="close") {
				if ($v1[$i]['tag']=="DESCRIPTION")
					printf("<tr><td>%s</td><td> No %s #%d </td><td> <a href='%s&scene=%d'> activate </a></td></tr>",$v1[$i]['value'],$areaId,$sceneId,$cmdLine,$sceneId);
		    	$i++;
		    	}
			}
		}
	echo "</table>";
	}

?>

	<div data-role="page" id="one" data-theme="b">
		<div data-role="header"><h4>Z-Way home</h4></div> 
		<div data-role="content">
			<div data-role="fieldcontain">
    			<label for="name">Dashboard Message:</label>
    			<input type="text" name="name" id="name" value="Here is the latest"  />
			</div>
			<ul data-role="listview" data-theme="b">
				<li><a href="#rooms" data-transition="pop">Rooms</a></li>
				<li><a href="#sensors" data-transition="pop">Sensors</a></li>		
				<li><a href="#blinds" data-transition="pop">Windows</a></li>
				<li><a href="#heatings" data-transition="pop">Heating</a></li>				
				<li><a href="#lights" data-transition="pop">Lights</a></li>	
				<li><a href="#devices" data-transition="pop">Devices</a></li>
			</ul>
		</div> 
		<div data-role="footer" data-theme="b"><h4>(c) 2011 Z-Wave.Me</h4></div> 
	</div>  
	<div data-role="page" id="rooms" data-theme="b">
		<div data-role="header" data-theme="b"><h4>Rooms</h4></div> 
		<div data-role="content">
		<div data-role="content">
			<ul data-role="listview" data-theme="b">
				<?
				printAreas();
				?>
			</ul>			
			<?
			echo "<hr>";
			printScenes();
			?>
 		</div> 
 		</div> 
		<div data-role="footer" data-theme="b"><h4>	
		<a href="#one" data-role="button" data-icon="home">Home</a></h4>
		</div> 
	</div> 
	<div data-role="page" id="sensors" data-theme="b">
		<div data-role="header" data-theme="b"><h4>Sensors</h4></div> 
		<div data-role="content">
			<?
			printSensors(0);
			?>
 		</div> 
		<div data-role="footer" data-theme="b"><h4>	
		<a href="#one" data-role="button" data-icon="home">Home</a></h4>
		</div> 
	</div> 	
	<div data-role="page" id="blinds" data-theme="b">
		<div data-role="header" data-theme="b"><h4>Blinds</h4></div> 
		<div data-role="content">
			<ul data-role="list-divider" data-theme="b">
			<?
			printSwitches('blind');
			?>
			</ul>
 		</div> 
		<div data-role="footer" data-theme="b"><h4>	
		<a href="#one" data-role="button" data-icon="home">Home</a></h4>
		</div> 
	</div> 	
	<div data-role="page" id="devices" data-theme="b">
		<div data-role="header" data-theme="b"><h4>Hardware</h4></div> 
		<div data-role="content">
			<ul data-role="listview" data-theme="b">
				<li><a href="#devicestatus" data-transition="pop">Device Status</a></li>
				<li><a href="#battery" data-transition="pop">Battery Status</a></li>
				<li><a href="#devicedata" data-transition="pop">Device Types</a></li>
			</ul>  
			</ul>
 		</div> 
		<div data-role="footer" data-theme="b"><h4>	
		<a href="#one" data-role="button" data-icon="home">Home</a></h4>
		</div> 
	</div> 
	<div data-role="page" id="battery" data-theme="b">
		<div data-role="header" data-theme="b"><h4>Battery Status</h4></div> 
		<div data-role="content">
			<?php printBatteries(); ?>
 		</div> 
		<div data-role="footer" data-theme="b"><h4>	
		<a href="#one" data-role="button" data-icon="home">Home</a></h4>
		</div> 
	</div> 		
	<div data-role="page" id="devicedata" data-theme="b">
		<div data-role="header" data-theme="b"><h4>Hardware</h4></div> 
		<div data-role="content">
			<? printDevices(); ?>
 		</div> 
		<div data-role="footer" data-theme="b"><h4>	
		<a href="#one" data-role="button" data-icon="home">Home</a></h4>
		</div> 
	</div> 	 	
	<div data-role="page" id="lights" data-theme="b">
		<div data-role="header" data-theme="b"><h4>Light</h4></div> 
		<div data-role="content">
			<ul data-role="list-divider" data-theme="b">
			<?
			printSwitches('light');
			?>
			</ul>
 		</div> 
		<div data-role="footer" data-theme="b"><h4>	
		<a href="#one" data-role="button" data-icon="home">Home</a></h4>
		</div> 
	</div> 		
	<div data-role="page" id="heatings" data-theme="b">
		<div data-role="header" data-theme="b"><h4>Heating</h4></div> 
		<div data-role="content">
			<?
			printHeatings();
			?>
 		</div> 
		<div data-role="footer" data-theme="b"><h4>	
		<a href="#one" data-role="button" data-icon="home">Home</a></h4>
		</div> 
	</div> 			



</body>
</html> 

<?

// displays

function printDevices(){
	global $data;
	foreach ($data['devices'] as $nodeId => $dev){
		if ($nodeId < 255 && $nodeId > $data['controller']['data']['nodeId']['value']) {
			$deviceType = $dev['data']['deviceTypeString']['value'];
			$vendor =$dev['data']['vendorString']['value'];
			$nstatus = getNodeStatus($dev);
	printf("<div data-role='collapsible'> <h3>%s </h3>
	<p><b>Device</b>: %s<br><b>Vendor</b>: %s<br><b>Z-Wave</b>: %s <br><b>Z-Wave</b>: %s <br><b>Power</b>: %s </p></div>",
	GetNodeName($dev,$nodeId,$instanceId,1),
	GetNodeName($dev,$nodeId,$instanceId,1),
	$vendor, $deviceType,getValueFromXml($dev['data']["ZDDXML"]['value'],"PRODUCTNAME"),$nstatus['type']);
 			}
		}
	}


function getValueFromXml($s,$value){
	$p = xml_parser_create();
	xml_parse_into_struct($p, $s, $v1, $v2);
	xml_parser_free($p);
	for ($i=0;$i<count($v1);$i++) if ($v1[$i]['tag']==$value) return $v1[$i]['value'];
 	}
 

	 
function printDeviceStatus(){
	global $data;
	foreach ($data['devices'] as $nodeId => $dev){
		if ($nodeId < 255 && $nodeId > $data['controller']['data']['nodeId']['value']) {
			$deviceType = $dev['data']['deviceTypeString']['value'];
			$vendor =$dev['data']['vendorString']['value'];
			$nstatus = getNodeStatus($dev);
			if (array_key_exists(0x84,$dev['instances'][0]['commandClasses'])) {// wakeup
				$ccd = $dev['instances'][0]['commandClasses'][0x84]['data'];
				$wakeupNext = (int)$ccd['lastSleep']['value'] + (int)$ccd['interval']['value'];
 				printf("<li>%s ... %s ...%s...%s next %s </li>",
 				GetNodeName($dev,$nodeId,0), $deviceType,$vendor,$nstatus['type'], date("H:i",$wakeupNext));
			}
			else {
 				printf("<li>%s .... %s ... %s ... %s/%s</li>",
 				GetNodeName($dev,$nodeId,0), $deviceType, $vendor,$nstatus['type'], $nstatus['status']);
 				}
 			}
		}
	}

function printSwitches($mode) { 
	global $data; 
	foreach ($data['devices'] as $nodeId => $dev){
		if ($nodeId < 255 && $nodeId > $data['controller']['data']['nodeId']['value']) 
			foreach ($dev['instances'] as $instanceId => $instance){	
				foreach ($instance['commandClasses'] as $ccId => $commandClass){
					if ($ccId == 0x25 && $mode=="light") {// switch 0x26
						$ccd = $commandClass['data'];
						echo CreateSwitchLine($ccId,$ccd,$nodeId);
						}
					if ($ccId == 0x26) {// MLswitch
						$ccd = $commandClass['data'];
						if((int)$data['devices'][$nodeId]['data']['specificType']['value'] > 2 && $mode=="blind")
						echo CreateBlindLine($ccId,$ccd,$nodeId);
						else
						echo CreateDimmerLine($ccId,$ccd,$nodeId);
						}
					}
				}
			}
	}
	
 


 
 
function PrintThermostats() { 
	global $data; 
	foreach ($data['devices'] as $nodeId => $dev){
		if ($nodeId < 255 && $nodeId > $data['controller']['data']['nodeId']['value']) 
			foreach ($dev['instances'] as $instanceId => $instance){	
				foreach ($instance['commandClasses'] as $ccId => $commandClass){
					if ($ccId == 0x46) {// climateschedule
						$ccd = $commandClass['data'];
						if($instance['commandClasses'][0x43])
							$temp=sprintf("%0.1f &#x00B0;C",$instance['commandClasses'][0x43]['data']['val']['value']);
						else $temp = "n.n.";
						echo CreateTRVLine($ccId,$ccd,$nodeId,$temp);
						}
					}
				}
			}
	}



function PrintSensors($meter) {
	global $data;
	getNames();
	foreach ($data['devices'] as $nodeId => $dev){
		if ($nodeId < 255 && $nodeId > $data['controller']['data']['nodeId']['value']) 
			foreach ($dev['instances'] as $instanceId => $instance){	
				foreach ($instance['commandClasses'] as $ccId => $commandClass){
					if ($ccId == 49 and !$meter) { // ML sensor
						$ccd = $commandClass['data'];
						if ($instanceId > 0 or count($dev['instances']) == 1)
							echo CreateMLSensorLine($ccd,$nodeId,$instanceId);
						}
					if ($ccId == 48 and !$meter) { // bin sensor
						$ccd = $commandClass['data'];
						echo CreateBinarySensorLine($ccd['level'],$nodeId,$instanceId);
						}
					if ($ccId == 50) { // Meter
						$ccd = $commandClass['data'];
						if ($instanceId > 0 or count($dev['instances']) == 1)
							for ($scale = 0; $scale < sizeof($ccd); $scale++) {
								if (sizeof($ccd[$scale]) and meterIsSensor($ccd,$scale) != $meter) echo CreateMLSensorLine($ccd[$scale],$nodeId,$instanceId);
							}
						}
					}
				}
			}
	}




function CreateTRVLine($ccId,$ccd,$nodeId, $temp){    
	global $_REQUEST;
	if ($ccd['overrideState']['value']) $status="Save"; else $status="Heat";
	$cmdLine=sprintf("./index.php?xid=%s&cmd=%s",$_REQUEST['xid'],$_REQUEST['cmd']);
	return sprintf ("<tr><td>%s </td><td align=right>%s </td><td> %s </td><td>(%s)</td><td><a href='%s&nodeId=%s&instance=%s&cc=%d&heat=122'>Save</a> <a href='%s&nodeId=%s&instance=%s&cc=%d&heat=0'>Heat</a></td></tr>",
	GetNodeName($dev,$nodeId,$instanceId),$temp,$status,getTimeStamp($ccd['overrideState']),$cmdLine,$nodeId,0,$ccId,$cmdLine,$nodeId,0,$ccId);
	}

function CreateBinarySensorLine($ccd,$nodeId){
	if ($ccd['value']) $status="open"; else $status="closed";
	return sprintf ("%s </td><td align=right>Binary</td><td align = right> %s </td><td>%s</td></tr>",
	GetNodeName($dev,$nodeId,$instanceId),$status, getTimeStamp($ccd));
	}

function CreateMLSensorLine($ccd,$nodeId,$instanceId){
	return sprintf ("<div data-role='collabsible'><h3>%s %.1f %s</h3> <p>%s is %s %.1f %s (%s)</p></div>",
	GetNodeName($dev,$nodeId,$instanceId,1),$ccd['val']['value'],$ccd['scaleString']['value'],
	GetNodeName($dev,$nodeId,$instanceId,0), $ccd['sensorTypeString']['value'],$ccd['val']['value'],
	$ccd['scaleString']['value'],getTimeStamp($ccd['val']));
	}


function printBatteries() {
	global $data;
	foreach ($data['devices'] as $nodeId => $dev){
		foreach ($dev['instances'][0]['commandClasses'] as $ccId => $commandClass){
			if ($ccId == 0x80) { // battery
				$ccd = $commandClass['data'];
	$a=	$ccd['last']['value'];
	$dval = $ccd['last']['updateTime']-$ccd['lastChange']['updateTime'];
	$x = $ccd['last']['updateTime'] + $dval/(100-$a) * $a;
	printf("<div data-role='collapsible'> <h3>%s : %d %%</h3>
	<p><b>Device</b>: %s<br><b>Status</b>: %d %% @ %s<br><b>Battery Type</b>: %s <br>
	<b>Estimated Date of Renewal</b>: %s </p></div>",
	GetNodeName($dev,$nodeId,$instanceId,1),$ccd['last']['value'],
	GetNodeName($dev,$nodeId,$instanceId,1),$ccd['last']['value'],
	date("d/m/Y H:i",(int)$ccd['updateTime']),getBatteriesFromXml($dev['data']["ZDDXML"]['value']),
	date("d/m/Y ",(int)$x));
				}
			}
		}
	} 
 
function getBatteriesFromXml($s){
	$n = array();
	$p = xml_parser_create();
	$a = array();
	xml_parse_into_struct($p, $s, $v1, $v2);
	xml_parser_free($p);
	for ($i=0;$i<count($v1);$i++) {
		if ($v1[$i]['tag']=="BATTERYTYPE") $type = $v1[$i]['value'];
		if ($v1[$i]['tag']=="BATTERYCOUNT") $count = $v1[$i]['value'];
		}
	return sprintf ("%d * %s",$count, $type);
	} 
 

//helpers

function PostRequest($path, $referer, $_data, $mode=0) {
	global $host, $port;
    $data = array();    
    while(list($n,$v) = each($_data)){ $data[] = "$n=$v"; }    
    $data = implode('&', $data);
    $fp = fsockopen($host, $port);
    fputs($fp, "POST $path HTTP/1.1\r\n");
    fputs($fp, "Host: $host\r\n");
    fputs($fp, "Referer: $referer\r\n");
    fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
    fputs($fp, "Content-length: ". strlen($data) ."\r\n");
    fputs($fp, "Connection: close\r\n\r\n");
    fputs($fp, $data);
    $result = ''; 
    while(!feof($fp)) { $result .= fgets($fp, 128); }
    fclose($fp);
    $result = explode("Connection: close", $result, 2);
    $header = isset($result[0]) ? $result[0] : '';
    $content = isset($result[1]) ? $result[1] : '';
    return $content;
	}

function getNames(){
	$n = array();
	$p = xml_parser_create();
	$a = array();
	xml_parse_into_struct($p, PostRequest("/Config/Rules/Get", "", array(),true), $v1, $v2);
	xml_parser_free($p);
	for ($i=0;$i<count($v1);$i++) 
		if ($v1[$i]['tag']=="AREAS" && $v1[$i]['type']=="open") 
		    while (++$i<count($v1) && $v1[$i]['type']!="close") $a[intval($v1[$i]['attributes']['ID'])] = $v1[$i]['attributes']['NAME'];	
	for ($i=0;$i<count($v1);$i++) 
		if ($v1[$i]['tag']=="DEVICES" && $v1[$i]['type']=="open") 
		    while (++$i<count($v1) && $v1[$i]['type']!="close") 
		    	$n[intval($v1[$i]['attributes']['DEVICE'])] = sprintf("%s @ %s",
		    	$v1[$i]['attributes']['DESCRIPTION'],$a[intval($v1[$i]['attributes']['AREA'])]); 
	return $n;
	}

function getNodeStatus($dev) {
	$ret = array('type' => "unknown", 'status' => "unknown");
	if ($dev['data']['isListening']['value'])
		$ret['type']= "Mains";
	elseif ($dev['data']['isVirtual']['value'])
		$ret['type']= "Virtual";
	elseif ($dev['data']['sensor250']['value'])
		$ret['type']= "FLIRS"; 
	elseif ($dev['data']['sensor1000']['value'])
		$ret['type']= "FLIRS";  
	else 	
 		$ret['type']= "Battery"; 
	if ($dev['data']['isAwake']['value'])
		$ret ['status']= "awake";
	elseif ($dev['data']['isFailed']['value'])
		$ret ['status']= "dead";
	else if ($dev['data']['isListening']['value'])
		$ret ['status']= "ok";
	else
		$ret ['status']= "sleep";	
	return $ret;
	}


function GetNodeName($dev,$nodeId,$instanceId,$mode=1) {
	global $nodeNames;
	if ($nodeNames[$nodeId]) {
		if($mode==1) return $nodeNames[$nodeId];	
		}
		else
			if ($instanceId)	return $nodeNames[$nodeId]." (#".$nodeId.".".$instanceId.")";
			else	return $nodeNames[$nodeId]." (#".$nodeId.")";
	if ($instanceId)	return "Node #".$nodeId.".".$instanceId."";
	else	return "Node #".$nodeId."";
	}

function meterIsSensor($ccId,$scale) {
    if ( $scale == 2) return true;
	return false;
	}

function getTimeStamp($ar) {
	if ($ar['updated'] == "True") return sprintf("<font color=green>%s</font>",date("H:i",(int)$ar['updateTime']));
	else return sprintf("<font color=red>%s</font>",date("H:i",(int)$ar['updateTime']));
	}

function parseAreas(){
	$r = array();
	$p = xml_parser_create();
	xml_parse_into_struct($p, PostRequest("/Config/Rules/Get", "", array(),true), $v1, $v2);
	xml_parser_free($p);
	for ($i=0;$i<count($v1);$i++) {
		if ($v1[$i]['tag']=="AREAS" && $v1[$i]['type']=="open") {
			$i = parseX2($v1, $i, $v1[$i]['attributes']['ID']);
			$i++;
			}
		}
	}

function parseX2($v1,$i,$p) { 
	global $rooms;
	while ($i<count($v1) && $v1[$i]['type']!="close") {
		$areaId = $v1[$i]['attributes']['ID'];
		$areaName = $v1[$i]['attributes']['NAME'];
		$level = $v1[$i]['level'];
		if ($areaId)
		$rooms[$areaId] = array('id' =>$areaId,'name' =>$areaName,'level' =>$v1[$i]['level'],'parent' =>$p);
		if ($v1[$i]['type']=="open")
			$i = parseX2($v1,$i+1,$v1[$i]['attributes']['ID']);
		$i++;
		}
 	return $i;
} 

?>
 